
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[Netty] Netty 超时机制及心跳程序实现 / 憋错料</title>

    <meta name="description" content="[Netty] Netty 超时机制及心跳程序实现 本文介绍了 Netty 超时机制的原理,以及如何在连接闲置时发送一个心跳来维持连接. Netty 超时机制的介绍 Netty 的超时类型 IdleState 主要分为: ALL_IDLE : 一段时间内没有数据接收或者发送 READER_IDLE :    一段时间内没有数据接收 WRITER_IDLE :     一段时间内没有数据发送 在 Netty 的 timeout 包下,主要类有: IdleStateEvent :     超时的事件 IdleStateHandler : 超时状态处理">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">[Netty] Netty 超时机制及心跳程序实现</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>　　本文介绍了 Netty 超时机制的原理，以及如何在连接闲置时发送一个心跳来维持连接。</p>
<p><strong>Netty 超时机制的介绍</strong></p>
<p>　　Netty 的超时类型 IdleState 主要分为：</p>
<p>　　　　ALL_IDLE : 　　　　一段时间内没有数据接收或者发送</p>
<p>　　　　READER_IDLE ：&nbsp; &nbsp; 一段时间内没有数据接收</p>
<p>　　　　WRITER_IDLE ：&nbsp; &nbsp; &nbsp;一段时间内没有数据发送</p>
<p>　　在 Netty 的 timeout 包下，主要类有：</p>
<p>　　　　IdleStateEvent ： 　　&nbsp; &nbsp; 超时的事件</p>
<p>　　　　IdleStateHandler ： 　　超时状态处理</p>
<p>　　　　ReadTimeoutHandler ： 读超时状态处理</p>
<p>　　　　WriteTimeoutHandler ： 写超时状态处理</p>
<p>　　其中 IdleStateHandler 包含了读\写超时状态处理，比如</p>
<p>　　　　private static final int 　　READ_IDEL_TIME_OUT 　　= 4; 　　// 读超时</p>
<p>　　　　private static final int 　　WRITE_IDEL_TIME_OUT 　&nbsp; = 5;　　// 写超时</p>
<p>　　　　private static final int 　　ALL_IDEL_TIME_OUT 　　&nbsp; &nbsp; = 7; 　&nbsp; // 所有超时</p>
<p>　　　　new IdleStateHandler(READ_IDEL_TIME_OUT,&nbsp;WRITE_IDEL_TIME_OUT, ALL_IDEL_TIME_OUT, TimeUnit.SECONDS));</p>
<p>　　上述例子，在 IdleStateHandler 中定义了读超时的时间是 4 秒， 写超时的时间是 5 秒，其他所有的超时时间是 7 秒。</p>
<p><strong>应用 IdleStateHandler</strong></p>
<p>　　既然 IdleStateHandler 包括了读\写超时状态处理，那么很多时候 ReadTimeoutHandler 、 WriteTimeoutHandler 都可以不用使用。定义另一个名为 HeartbeatHandlerInitializer 的 ChannelInitializer ：</p>
<p>public class HeartbeatHandlerInitializer extends ChannelInitializer {</p>
<p>　　private static final int READ_IDEL_TIME_OUT = 4; // 读超时</p>
<p>　　private static final int WRITE_IDEL_TIME_OUT = 5;// 写超时</p>
<p>　　private static final int ALL_IDEL_TIME_OUT = 7; // 所有超时</p>
<p>　　@Override</p>
<p>　　protected void initChannel(Channel ch) throws Exception {</p>
<p>　　　　ChannelPipeline pipeline = ch.pipeline();</p>
<p>　　　　pipeline.addLast(new IdleStateHandler(READ_IDEL_TIME_OUT,&nbsp;WRITE_IDEL_TIME_OUT, ALL_IDEL_TIME_OUT, TimeUnit.SECONDS)); // 1</p>
<p>　　　　pipeline.addLast(new HeartbeatServerHandler()); // 2</p>
<p>　　}</p>
<p>}</p>
<p>　　使用了 IdleStateHandler ，分别设置了读、写超时的时间，定义了一个 HeartbeatServerHandler 处理器，用来处理超时时，发送心跳定义了一个心跳处理器</p>
<p>public class HeartbeatServerHandler extends ChannelInboundHandlerAdapter {</p>
<p>　　// Return a unreleasable view on the given ByteBuf</p>
<p>　　// which will just ignore release and retain calls.</p>
<p>　　private static final ByteBuf HEARTBEAT_SEQUENCE = Unpooled.unreleasableBuffer(Unpooled.copiedBuffer("Heartbeat",&nbsp;CharsetUtil.UTF_8));&nbsp; // 1</p>
<p>　　@Override</p>
<p>　　public void userEventTriggered(ChannelHandlerContext ctx, Object evt)&nbsp;throws Exception {</p>
<p>　　　　if (evt instanceof IdleStateEvent) {&nbsp; // 2</p>
<p>　　　　　　IdleStateEvent event = (IdleStateEvent) evt;</p>
<p>　　　　　　String type = "";</p>
<p>　　　　　　if (event.state() == IdleState.READER_IDLE) {</p>
<p>　　　　　　　　type = "read idle";</p>
<p>　　　　　　} else if (event.state() == IdleState.WRITER_IDLE) {</p>
<p>　　　　　　　　type = "write idle";</p>
<p>　　　　　　} else if (event.state() == IdleState.ALL_IDLE) {</p>
<p>　　　　　　　　type = "all idle";</p>
<p>　　　　　　}</p>
<p>　　　　　　ctx.writeAndFlush(HEARTBEAT_SEQUENCE.duplicate()).addListener(ChannelFutureListener.CLOSE_ON_FAILURE);&nbsp; // 3</p>
<p>　　　　　　System.out.println( ctx.channel().remoteAddress()+"超时类型：" + type);</p>
<p>　　　　} else {</p>
<p>　　　　　　super.userEventTriggered(ctx, evt);</p>
<p>　　　　}</p>
<p>　　}</p>
<p>}</p>
<p>　　定义了心跳时，要发送的内容判断是否是 IdleStateEvent 事件，是则处理将心跳内容发送给客户端</p>
<p><strong>服务器</strong></p>
<p>　　服务器代码比较简单，启动后侦听 8082 端口</p>
<p>public final class HeartbeatServer {</p>
<p>　　static final int PORT = 8082;</p>
<p>　　public static void main(String[] args) throws Exception {</p>
<p>　　　　// Configure the server.</p>
<p>　　　　EventLoopGroup bossGroup = new NioEventLoopGroup(1);</p>
<p>　　　　EventLoopGroup workerGroup = new NioEventLoopGroup();</p>
<p>　　　　try {</p>
<p>　　　　　　ServerBootstrap b = new ServerBootstrap();</p>
<p>　　　　　　b.group(bossGroup, workerGroup)</p>
<p>　　　　　　　　.channel(NioServerSocketChannel.class)</p>
<p>　　　　　　　　.option(ChannelOption.SO_BACKLOG, 100)</p>
<p>　　　　　　　　.handler(new LoggingHandler(LogLevel.INFO))</p>
<p>　　　　　　　　.childHandler(new HeartbeatHandlerInitializer());</p>
<p>　　　　　　// Start the server.</p>
<p>　　　　　　ChannelFuture f = b.bind(PORT).sync();</p>
<p>　　　　　　// Wait until the server socket is closed.</p>
<p>　　　　　　f.channel().closeFuture().sync();</p>
<p>　　　　} finally {</p>
<p>　　　　　　// Shut down all event loops to terminate all threads.</p>
<p>　　　　　　bossGroup.shutdownGracefully();</p>
<p>　　　　　　workerGroup.shutdownGracefully();</p>
<p>　　　　}</p>
<p>　　}</p>
<p>}</p>
<p><strong>客户端测试</strong></p>
<p>　　客户端用操作系统自带的 Telnet 程序即可：</p>
<p>　　　　telnet 127.0.0.1 8082</p>
<p><strong>效果</strong></p>
<p>　　20151106-heartbeat</p>
<p><strong>源码</strong></p>
<p>　　见<a href="https://link.jianshu.com?t=https%3A%2F%2Fgithub.com%2Fwaylau%2Fnetty-4-user-guide-demos" rel="external nofollow noreferrer">https://github.com/waylau/netty-4-user-guide-demos</a>中 heartbeat包</p>
<p>作者：Java高级架构<br />链接：https://www.jianshu.com/p/770b2d5f40cd<br />来源：简书<br />著作权归作者所有。商业转载请联系作者获得授权，非商业转载请注明出处。</p>

<p>原文地址：https://www.cnblogs.com/wxxujian/p/12708177.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-17 05:52:48 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.biecuoliao.com/tag/ase/" title="ase">ase</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%9a%e4%b9%89/" title="定义">定义</a>, <a href="https://www.biecuoliao.com/tag/ring/" title="ring">ring</a>, <a href="https://www.biecuoliao.com/tag/tty/" title="tty">tty</a>, <a href="https://www.biecuoliao.com/tag/apt/" title="apt">apt</a>, <a href="https://www.biecuoliao.com/tag/%e8%91%97%e4%bd%9c%e6%9d%83/" title="著作权">著作权</a>, <a href="https://www.biecuoliao.com/tag/adapter/" title="adapter">adapter</a>, <a href="https://www.biecuoliao.com/tag/tst/" title="TST">TST</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>[Netty] Netty 超时机制及心跳程序实现的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KBokKM.html" rel="bookmark">Netty 超时机制及心跳程序实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Netty 超时机制的介绍 Netty 的超时类型 IdleState 主要分为: ALL_IDLE : 一段时间内没有数据接收或者发送 READER_IDLE : 一段时间内没有数据接收 WRITER_IDLE : 一段时间内没有数据发送 在 Netty 的 timeout 包下,主要类有: IdleStateEvent : 超时的事件 IdleStateHandler : 超时状态处理 ReadTimeoutHandler : 读超时状态处理 WriteTimeoutHandler : 写超			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bZAyp0.html" rel="bookmark">关于Netty对于Channel超时机制缺陷的一点想法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们看看ReadTimeoutHandler下面这个初始化方法,在初始化的时候做的一些事情,Netty的2个改进点我认为都在这里可以体现出来(下面红体): private void initialize(ChannelHandlerContext ctx) { // Avoid the case where destroy() is called before scheduling timeouts. // See: https://github.com/netty/netty/issues/1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPxq1DM.html" rel="bookmark">基于Netty的IdleStateHandler实现Mqtt心跳</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于Netty的IdleStateHandler实现Mqtt心跳 IdleStateHandler解析 最近研究jetlinks编写的基于Netty的mqtt-client(https://github.com/jetlinks/netty-mqtt-client),总结若干知识点. Netty中,实现心跳机制较为简单,主要依赖于IdleStateHandler判断channel的读写超时. /** * Creates a new instance firing {@link IdleState			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mgn1wR4.html" rel="bookmark">【您还有心跳吗？超时机制分析 】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 在C/S模式中,有时我们会长时间保持一个连接,以避免频繁地建立连接,但同时,一般会有一个超时时间,在这个时间内没发起任何请求的连接会被断开,以减少负载,节约资源.并且该机制一般都是在服务端实现,因为client强制关闭或意外断开连接,server端在此刻是感知不到的,如果放到client端实现,在上述情况下,该超时机制就失效了.本来这问题很普通,不太值得一提,但最近在项目中看到了该机制的一种糟糕的实现,故在此深入分析一下. 问题分析及解决方案 服务端一般会保持很多个连接,所以,一般是创			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aY5Wk0.html" rel="bookmark">您还有心跳吗？超时机制分析&lpar;java&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 在C/S模式中,有时我们会长时间保持一个连接,以避免频繁地建立连接,但同时,一般会有一个超时时间,在这个时间内没发起任何请求的连接会被断开,以减少负载,节约资源.并且该机制一般都是在服务端实现,因为client强制关闭或意外断开连接,server端在此刻是感知不到的,如果放到client端实现,在上述情况下,该超时机制就失效了.本来这问题很普通,不太值得一提,但最近在项目中看到了该机制的一种糟糕的实现,故在此深入分析一下. 问题分析及解决方案 服务端一般会保持很多个连接,所以,一般是创			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KYbEj4.html" rel="bookmark">Android超时机制的处理（很不错）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于手机端应用的响应,与当时的无线通信网络状况有很大的关联.而通信网络往往具有不稳定,延迟长的特点.所以,在我们的应用程序中,当我们请求网络的时候,超时机制的应用就显得特别重要. 超时机制主要有: 1.HTTP请求超时机制 2.Socket通信超时机制 HTTP请求超时机制 public static void main(String[] args){ long a=System.currentTimeMillis(); try{ URL myurl = new URL(“http://www.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rnWmq3.html" rel="bookmark">python调用函数设置超时机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有时候需要给函数设置超时机制,以防止它卡住我们的程序,这里可以用python的signal模块,signal模块可以实现程序内部的信号处理. # coding:utf8 import time import signal # 自定义超时异常 class TimeoutError(Exception): def __init__(self, msg): super(TimeoutError, self).__init__() self.msg = msg def time_out(interval			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pRRqy0.html" rel="bookmark">&lpar;HttpClient超时机制&rpar;timeout调度算法探讨</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mark一下: HttpClient超时机制(安全问题处理:访问超大文件控制) 不过httpclient4开始好象没有MultiThreadedHttpConnectionManager这个类了,代替的应该是:PoolingHttpClientConnectionManager.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0en6da3.html" rel="bookmark">Java并发框架&mdash;&mdash;AQS超时机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				AQS框架提供的另外一个优秀机制是锁获取超时的支持,当大量线程对某一锁竞争时可能导致某些线程在很长一段时间都获取不了锁,在某些场景下可能希望如果线程在一段时间内不能成功获取锁就取消对该锁的等待以提高性能,这时就需要用到超时机制.在JDK1.5之前还没有juc工具,当时的并发控制职能通过JVM内置的synchronized关键词实现锁,但对一些特殊要求却力不从心,例如超时取消控制.JDK1.5开始引入juc工具完美解决了此问题,而这正得益于并发基础框架AQS提供了超时的支持. 为了更精确地保证时间			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RB78j0.html" rel="bookmark" class="title">关于composer安装插件时候提示找不到fxp插件时候的解决办法</a>
					<div>
						如果你在某个目录使用composer.phar,而且在别的目录页使用了composer,并没有全局安装composer的时候,不同目录之间的可能会互相干扰从而报错 [email protected]: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEoGrP3.html" rel="bookmark" class="title">离线破win2003域账号密码</a>
					<div>
						离线破win2003域账号密码 国内网站讲了许多方法.把我实验成功的经验跟大家分享. 方法是按照tim的文章操作,链接如下: http://pauldotcom.com/2011/11/safely- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzazX84.html" rel="bookmark" class="title">预定义常量</a>
					<div>
						PDO::PARAM_BOOL (integer) 表示布尔数据类型. PDO::PARAM_NULL (integer) 表示 SQL 中的 NULL 数据类型. PDO::PARAM_INT (i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bneYw0.html" rel="bookmark" class="title">QT项目性能调优小记</a>
					<div>
						最近的项目用到了QT 5.5,项目在运行过程中出现了一段时间CPU占用率持续25%,并频繁断网的情况,遂决定对项目性能进行优化. 优化工具也是VS2010自带的性能分析工具,具体的使用方法参见:htt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AdDVv3.html" rel="bookmark" class="title">值得学习的C&sol;C&plus;&plus;开源框架（转）</a>
					<div>
						值得学习的C语言开源项目 - 1. Webbench Webbench是一个在linux下使用的非常简单的网站压测工具.它使用fork()模拟多个客户端同时访问我们设定的URL,测试网站在压力下工作的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZx1n3.html" rel="bookmark" class="title">leetcode 题解代码整理  1-5题</a>
					<div>
						Two Sum Given an array of integers, find two numbers such that they add up to a specific target numb ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Am2dZ4.html" rel="bookmark" class="title">邻接矩阵无向图的介绍</a>
					<div>
						邻接矩阵无向图是指通过邻接矩阵表示的无向图. 上面的图G1包含了&quot;A,B,C,D,E,F,G&quot;共7个顶点,而且包含了&quot;(A,C),(A,D),(A,F),(B,C),(C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J8LzV0.html" rel="bookmark" class="title">Java基础の第一弹</a>
					<div>
						一.虚拟机的工作机制 (1) :通过 ClassLoader 寻找和装载 class 文件 (2) :解释字节码成为指令并执行,提供 class 文件的运行环境 (3) :进行运行期间垃圾回收 (4) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5lRW3.html" rel="bookmark" class="title">Mac系统中常用快捷键</a>
					<div>
						刚刚接触IOS系统,收集了一些快捷键和系统指令,以便能更好的学习IOS开发. 一.文件操作    复制:Command + C      粘贴:Command + V    回退:Command +  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38werK0.html" rel="bookmark" class="title">BZOJ 2508 简单题 数学算法</a>
					<div>
						题目大意:维护一个平面,支持三种操作: 0.加入一条直线(给的是两点式) 1.删除一条直线 2.询问到所有直线距离平方和最小的点 题解见 http://blog.sina.com.cn/s/blog_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lWgJbM.html" rel="bookmark" class="title">剑指offer&mdash;&mdash;树的子结构 （JAVA代码）</a>
					<div>
						版权声明:本文为博主原创文章,未经博主允许不得转载. 题目描述: 输入两棵二叉树A,B,判断B是不是A的子结构.(ps:我们约定空树不是任意一个树的子结构). 解题思路: 首先看牛客网给出的测试用例: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nLrav4.html" rel="bookmark" class="title">vs2010设置编辑器背景颜色</a>
					<div>
						在nopad++中,双击选中某个关键字后,在文档中所有出现该关键字的地方都会高亮,非常方便查看在那些地方有调用. VS2010的默认颜色不够明显(尤其是将系统背景色改为 苹果绿保护色(Hue:85,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmYw7M.html" rel="bookmark" class="title">令人抱怨的专车动态加价机制，到底公不公平？</a>
					<div>
						从滴滴到易到.神州,甚至已经&quot;国有化&quot;且被收购的中国优步,几乎全都已经开启了动态加价机制.而这种去年开启就备受争议的加价机制,在运营了一年多之后依然备受争议.无论是&quot;恐怖 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJjD13.html" rel="bookmark" class="title">cocos2d-js Shader系列4：Shader、GLProgram在jsb（native、手机）和html5之间的兼容问题。cocos2d-js框架各种坑。</a>
					<div>
						为了让jsb也能顺利跑起滤镜效果,在手机侧折腾了2天,因为每次在真机上运行总要耗那么半分钟,而且偶尔还遇到apk文件无法删除导致运行失败的情况. 这个调试起来,实在让人烦躁加沮丧. 还好,测试上百轮, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OpxbX4.html" rel="bookmark" class="title">关于更新到Xcode8的一些问题</a>
					<div>
						随着iOS 10的陆续使用,升级到xcode8也是大势所趋. 虽然现在xcode 8 可能还有一些问题,但是整体还是不错的,对一些常用的插件也做了集成,比如说 ///注释快捷键 下面说一下我遇到的一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YWrEv4.html" rel="bookmark" class="title">SPL接口学习总结</a>
					<div>
						迭代器接口描述(接口在C里定义,这只是描述) interface Iterator { public function current(); public function key(); public ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWQWvb3.html" rel="bookmark" class="title">实现图片旋转木马3D浏览效果</a>
					<div>
						&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J2rKY4.html" rel="bookmark" class="title">Linux下基于select的socket通信</a>
					<div>
						select函数介绍: int select(int maxfdp,fd_set *readfds,fd_set *writefds,fd_set *errorfds,struct timeval * ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPgXXP4.html" rel="bookmark" class="title">OA、协同OA、协同管理平台的区别</a>
					<div>
						一方面,由于管理软件相关知识普及度不高:另一方面,由于OA厂商宣传口号的混淆,对于刚刚接触OA系统的用户来说,很难分清OA.协同OA.协同办公平台三者之间的区别.笔者就这三个名词做简单的分析说明以供参 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyzVOn0.html" rel="bookmark" class="title">erlang分布式编程模型</a>
					<div>
						erlang分布式编程有两种模型 一.分布式erlang 运行在可信的网络环境中 1.rpc提供的远程过程调用 rpc:call(Node,Mode,Fun,Args) -&gt;Result|{ba ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
